#ifndef EFL_OBSERVABLE_EO_HH
#define EFL_OBSERVABLE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_object.eo.h"
#include "efl_observable.eo.h"
#include "efl_observer.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_object.eo.hh"
#include "efl_observer.eo.hh"
namespace efl { 
struct Observable;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Observable> : ::std::true_type {}; } }
namespace efl { 
struct Observable;
} 
namespace efl { 
struct Object;
} 
namespace efl { 
struct Observer;
} 

namespace eo_cxx {
namespace efl { 
struct Observable {
   ::efl::eolian::return_traits<void>::type observer_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits< ::efl::Observer>::type obs) const;
   ::efl::eolian::return_traits<void>::type observer_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits< ::efl::Observer>::type obs) const;
   ::efl::eolian::return_traits<void>::type observer_clean( ::efl::eolian::in_traits< ::efl::Observer>::type obs) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::Observer>>::type observers_iterator_new( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   ::efl::eolian::return_traits<void>::type observers_update( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator<Efl_Observable_Tuple>>::type iterator_tuple_new() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_OBSERVABLE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::Observable() const;
   operator ::efl::Observable&();
   operator ::efl::Observable const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Observable,  ::efl::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Observable const ,  ::efl::Object const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Observable : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Object)
{
   explicit Observable( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Observable(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Observable(Observable const& other) = default;
   Observable(Observable&& other) = default;
   Observable& operator=(Observable const& other) = default;
   Observable& operator=(Observable&& other) = default;
   Observable()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Observable( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Observable(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type observer_add( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits< ::efl::Observer>::type obs) const;
   ::efl::eolian::return_traits<void>::type observer_del( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits< ::efl::Observer>::type obs) const;
   ::efl::eolian::return_traits<void>::type observer_clean( ::efl::eolian::in_traits< ::efl::Observer>::type obs) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator< ::efl::Observer>>::type observers_iterator_new( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key) const;
   ::efl::eolian::return_traits<void>::type observers_update( ::efl::eolian::in_traits< ::efl::eina::string_view>::type key,  ::efl::eolian::in_traits<void*>::type data) const;
   ::efl::eolian::return_traits< ::efl::eina::iterator<Efl_Observable_Tuple>>::type iterator_tuple_new() const;
   static Efl_Class const* _eo_class()
   {
      return EFL_OBSERVABLE_CLASS;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Observable,  ::efl::Object> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Observable const ,  ::efl::Object const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Observable) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Observable>::value, "");
} 
#endif
