#ifndef EFL_UI_RANGE_EO_HH
#define EFL_UI_RANGE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_range.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace ui { 
struct Range;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Range> : ::std::true_type {}; } }
namespace efl { namespace ui { 
struct Range;
} } 

namespace eo_cxx {
namespace efl { namespace ui { 
struct Range {
   ::efl::eolian::return_traits<int>::type span_size_get() const;
   ::efl::eolian::return_traits<void>::type span_size_set( ::efl::eolian::in_traits<int>::type size) const;
   ::efl::eolian::return_traits<double>::type range_value_get() const;
   ::efl::eolian::return_traits<void>::type range_value_set( ::efl::eolian::in_traits<double>::type val) const;
   ::efl::eolian::return_traits<void>::type range_min_max_get( ::efl::eolian::out_traits<double>::type min,  ::efl::eolian::out_traits<double>::type max) const;
   ::efl::eolian::return_traits<void>::type range_min_max_set( ::efl::eolian::in_traits<double>::type min,  ::efl::eolian::in_traits<double>::type max) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type range_unit_format_get() const;
   ::efl::eolian::return_traits<void>::type range_unit_format_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type units) const;
   ::efl::eolian::return_traits<bool>::type range_interval_enabled_get() const;
   ::efl::eolian::return_traits<void>::type range_interval_enabled_set( ::efl::eolian::in_traits<bool>::type enable) const;
   ::efl::eolian::return_traits<void>::type range_interval_get( ::efl::eolian::out_traits<double>::type from,  ::efl::eolian::out_traits<double>::type to) const;
   ::efl::eolian::return_traits<void>::type range_interval_set( ::efl::eolian::in_traits<double>::type from,  ::efl::eolian::in_traits<double>::type to) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_RANGE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::Range() const;
   operator ::efl::ui::Range&();
   operator ::efl::ui::Range const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Range> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Range const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Range : ::efl::eo::concrete
{
   explicit Range( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Range(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Range(Range const& other) = default;
   Range(Range&& other) = default;
   Range& operator=(Range const& other) = default;
   Range& operator=(Range&& other) = default;
   Range()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Range( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Range(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<int>::type span_size_get() const;
   ::efl::eolian::return_traits<void>::type span_size_set( ::efl::eolian::in_traits<int>::type size) const;
   ::efl::eolian::return_traits<double>::type range_value_get() const;
   ::efl::eolian::return_traits<void>::type range_value_set( ::efl::eolian::in_traits<double>::type val) const;
   ::efl::eolian::return_traits<void>::type range_min_max_get( ::efl::eolian::out_traits<double>::type min,  ::efl::eolian::out_traits<double>::type max) const;
   ::efl::eolian::return_traits<void>::type range_min_max_set( ::efl::eolian::in_traits<double>::type min,  ::efl::eolian::in_traits<double>::type max) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type range_unit_format_get() const;
   ::efl::eolian::return_traits<void>::type range_unit_format_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type units) const;
   ::efl::eolian::return_traits<bool>::type range_interval_enabled_get() const;
   ::efl::eolian::return_traits<void>::type range_interval_enabled_set( ::efl::eolian::in_traits<bool>::type enable) const;
   ::efl::eolian::return_traits<void>::type range_interval_get( ::efl::eolian::out_traits<double>::type from,  ::efl::eolian::out_traits<double>::type to) const;
   ::efl::eolian::return_traits<void>::type range_interval_set( ::efl::eolian::in_traits<double>::type from,  ::efl::eolian::in_traits<double>::type to) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_RANGE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Range> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Range const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Range) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Range>::value, "");
} } 
#endif
