#ifndef EFL_UI_TEXT_INTERACTIVE_EO_HH
#define EFL_UI_TEXT_INTERACTIVE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_text.eo.h"
#include "efl_text_font.eo.h"
#include "efl_text_format.eo.h"
#include "efl_text_style.eo.h"
#include "efl_ui_text_interactive.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_text.eo.hh"
#include "efl_text_font.eo.hh"
#include "efl_text_format.eo.hh"
#include "efl_text_style.eo.hh"
namespace efl { namespace ui { namespace text { 
struct Interactive;
} } } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::text::Interactive> : ::std::true_type {}; } }
namespace efl { namespace ui { namespace text { 
struct Interactive;
} } } 
namespace efl { 
struct Text;
} 
namespace efl { namespace text { 
struct Font;
} } 
namespace efl { namespace text { 
struct Format;
} } 
namespace efl { namespace text { 
struct Style;
} } 

namespace eo_cxx {
namespace efl { namespace ui { namespace text { 
struct Interactive {
   ::efl::eolian::return_traits<bool>::type selection_allowed_get() const;
   ::efl::eolian::return_traits<void>::type selection_allowed_set( ::efl::eolian::in_traits<bool>::type allowed) const;
   ::efl::eolian::return_traits<void>::type selection_cursors_get( ::efl::eolian::out_traits<Efl_Text_Cursor_Cursor*>::type start,  ::efl::eolian::out_traits<Efl_Text_Cursor_Cursor*>::type end) const;
   ::efl::eolian::return_traits<bool>::type editable_get() const;
   ::efl::eolian::return_traits<void>::type editable_set( ::efl::eolian::in_traits<bool>::type editable) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_TEXT_INTERACTIVE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::ui::text::Interactive() const;
   operator ::efl::ui::text::Interactive&();
   operator ::efl::ui::text::Interactive const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Interactive,  ::efl::Text,  ::efl::text::Font,  ::efl::text::Format,  ::efl::text::Style> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Interactive const ,  ::efl::Text const ,  ::efl::text::Font const ,  ::efl::text::Format const ,  ::efl::text::Style const > operator&() const { return {this}; }
   /// @endcond
};
} } } 
}
namespace efl { namespace ui { namespace text { 
struct Interactive : ::efl::eo::concrete
   , EO_CXX_INHERIT( ::efl::Text)
   , EO_CXX_INHERIT( ::efl ::text::Font)
   , EO_CXX_INHERIT( ::efl ::text::Format)
   , EO_CXX_INHERIT( ::efl ::text::Style)
{
   explicit Interactive( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Interactive(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Interactive(Interactive const& other) = default;
   Interactive(Interactive&& other) = default;
   Interactive& operator=(Interactive const& other) = default;
   Interactive& operator=(Interactive&& other) = default;
   Interactive()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Interactive( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Interactive(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<bool>::type selection_allowed_get() const;
   ::efl::eolian::return_traits<void>::type selection_allowed_set( ::efl::eolian::in_traits<bool>::type allowed) const;
   ::efl::eolian::return_traits<void>::type selection_cursors_get( ::efl::eolian::out_traits<Efl_Text_Cursor_Cursor*>::type start,  ::efl::eolian::out_traits<Efl_Text_Cursor_Cursor*>::type end) const;
   ::efl::eolian::return_traits<bool>::type editable_get() const;
   ::efl::eolian::return_traits<void>::type editable_set( ::efl::eolian::in_traits<bool>::type editable) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_TEXT_INTERACTIVE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   static struct changed_user_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_TEXT_INTERACTIVE_EVENT_CHANGED_USER; }
      typedef Efl_Ui_Text_Interactive_Change_Info parameter_type;
   } const changed_user_event;
   static struct selection_changed_event
   {
      static Efl_Event_Description const* description()
      { return EFL_UI_TEXT_INTERACTIVE_EVENT_SELECTION_CHANGED; }
      typedef void parameter_type;
   } const selection_changed_event;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Interactive,  ::efl::Text,  ::efl::text::Font,  ::efl::text::Format,  ::efl::text::Style> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Interactive const ,  ::efl::Text const ,  ::efl::text::Font const ,  ::efl::text::Format const ,  ::efl::text::Style const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Interactive) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Interactive>::value, "");
} } } 
#endif
